local _o = {
	rect = require 'ent.rect',
	circle = require 'ent.circle'
}

local obj = {}

-- Create the inherit function:
function obj.inherit(model, args)
	local self = _o[model].inherit(args)

	self = {
		isDead 	= args.isDead or false,

		x 		= args.x,
		y 		= args.y,
		rot 	= 0,

		vx 		= 0,
		vy 		= 0,
		vrot 	= 0
	}

	-- The instance functions(every object will have them):
	function self:update(dt)
		-- Update the position and rotation based on velocity (vx, vy, and vrot)
		-- Multiply by dt(delta time) to produce an smooth movement, seperate from fps

		self.x = self.x + self.vx * dt
		self.y = self.y + self.vy * dt
		self.rot = self.rot + self.vrot * dt
	end

	function self:push(angle, force)
		-- Here we use a little trig to push the right way
		-- Note: 'angle' is a value between 0 and pi*2 (pi = 180 degrees)

		self.vx = self.vx + math.sin(angle) * force * dt
		self.vy = self.vy + math.cos(angle) * -force * dt
	end

	function self:turn(force)
		self.vrot = self.vrot + force * dt
	end




	return self -- return instance of 'self' containing the inherited functions and values
end

return obj