--[[
    This demo is for OOP(Object Orientated Programming) in Lua, we will be creating basic objects with
    inheritence. This can get complicated if you don't keep everything sorted...

    Another general rule of coding is to not repeat code. You don't want to rewrite all the functions
    and everything multiple times. Also repetative things can usually be put into tables and iterated 
    through instead of copy-pasting everything 10 times. Moving on.....

    You may have to keep switching between files to keep up with the inheritances, but it's pretty
    much straight-forward.
]]

-- Require 'ecs.lua' into the project... It really isn't a full-fledge Entity Component System, but it will do for now.
local ECS = require 'ecs'

function love.load()
    ECS.newEnt("circle", {x=100,y=100,r=10})
    ECS.newEnt("rect", {x=100,y=100,w=20,h=50})
end

function love.update(dt)
	ECS.update(dt)
end

function love.draw()
	ECS.draw()
end

function love.keypressed(k)
    if k == "escape" then love.event.quit() end
end
